Index: trunk/src/org/expeditee/items/Circle.java
===================================================================
--- trunk/src/org/expeditee/items/Circle.java	(revision 1142)
+++ trunk/src/org/expeditee/items/Circle.java	(revision 1143)
@@ -159,6 +159,6 @@
 		double radius = getRadius();
 
-		double distance = Math.sqrt(Math.pow(Math.abs(_center.getX() - p.x), 2)
-				+ Math.pow(Math.abs(_center.getY() - p.y), 2));
+		double distance = Math.sqrt(Math.pow(Math.abs(_center.getX() - p.getX()), 2)
+				+ Math.pow(Math.abs(_center.getY() - p.getY()), 2));
 
 		return Math.abs(distance - radius) < getGravity() * 2;
Index: trunk/src/org/expeditee/items/Item.java
===================================================================
--- trunk/src/org/expeditee/items/Item.java	(revision 1142)
+++ trunk/src/org/expeditee/items/Item.java	(revision 1143)
@@ -2149,5 +2149,5 @@
 
 	public void setPosition(Point position) {
-		setPosition(position.x, position.y);
+		setPosition(position.getX(), position.getY());
 	}
 
@@ -2881,6 +2881,6 @@
 		invalidateCommonTraitForAll(ItemAppearence.PreMoved);
 
-		_x = (float) (origin.x + ratio * (_x - origin.x));
-		_y = (float) (origin.y + ratio * (_y - origin.y));
+		_x = (float) (origin.getX() + ratio * (_x - origin.getX()));
+		_y = (float) (origin.getY() + ratio * (_y - origin.getY()));
 		invalidateBounds();
 		for (Line line : getLines())
Index: trunk/src/org/expeditee/items/ItemUtils.java
===================================================================
--- trunk/src/org/expeditee/items/ItemUtils.java	(revision 1142)
+++ trunk/src/org/expeditee/items/ItemUtils.java	(revision 1143)
@@ -971,6 +971,6 @@
 	private static void scaleItem(Vector v, Item item) {
 		Float scale = v.Scale;
-		int originX = v.Origin.x;
-		int originY = v.Origin.y;
+		int originX = v.Origin.getX();
+		int originY = v.Origin.getY();
 		Colour defaultForeground = v.Foreground;
 		Colour defaultBackground = v.Background;
Index: trunk/src/org/expeditee/items/Line.java
===================================================================
--- trunk/src/org/expeditee/items/Line.java	(revision 1142)
+++ trunk/src/org/expeditee/items/Line.java	(revision 1143)
@@ -227,6 +227,6 @@
 			 * else
 			 */{
-				_startOffset.x = 0;
-				_startOffset.y = 0;
+				_startOffset.setX(0);
+				_startOffset.setY(0);
 			}
 
@@ -245,6 +245,6 @@
 			 * end.getX(); _endOffset.y = _end.getY() - end.getY(); } else
 			 */{
-				_endOffset.x = 0;
-				_endOffset.y = 0;
+				_endOffset.setX(0);
+				_endOffset.setY(0);
 			}
 
@@ -377,5 +377,5 @@
 			// Add all the x and y's to the array
 			for (int j = 0; j < pointPath.size(); j++) {
-				path.addPoint(pointPath.get(j).x, pointPath.get(j).y);
+				path.addPoint(pointPath.get(j).getX(), pointPath.get(j).getY());
 			}
 		}
@@ -447,8 +447,8 @@
 		int x0, x1, y0, y1;
 
-		x1 = withArrow.getX() + startOffset.x;
-		y1 = withArrow.getY() + startOffset.y;
-		x0 = getOppositeEnd(withArrow).getX() + endOffset.x;
-		y0 = getOppositeEnd(withArrow).getY() + endOffset.y;
+		x1 = withArrow.getX() + startOffset.getX();
+		y1 = withArrow.getY() + startOffset.getY();
+		x0 = getOppositeEnd(withArrow).getX() + endOffset.getX();
+		y0 = getOppositeEnd(withArrow).getY() + endOffset.getY();
 
 		float arrowLength   = withArrow.getArrowheadLength();
@@ -499,5 +499,5 @@
 		arrowhead = arrowhead.clone();
 		double rad = calcAngle((float) x0, (float) y0, (float) x1, (float) y1);
-		arrowhead.translate((x0 + length) - arrowhead.toArray()[0].x, y0 - arrowhead.toArray()[0].y);
+		arrowhead.translate((x0 + length) - arrowhead.toArray()[0].getX(), y0 - arrowhead.toArray()[0].getY());
 		arrowhead.rotate(rad, x0, y0);
 		
@@ -609,5 +609,5 @@
 	public Item getEndPointToDisconnect(Point p)
 	{
-		return getEndPointToDisconnect(p.x, p.y);
+		return getEndPointToDisconnect(p.getX(), p.getY());
 	}
 
Index: trunk/src/org/expeditee/items/Picture.java
===================================================================
--- trunk/src/org/expeditee/items/Picture.java	(revision 1142)
+++ trunk/src/org/expeditee/items/Picture.java	(revision 1143)
@@ -207,5 +207,5 @@
 		String size = getImageSize();
 
-		if (_end.x != 0 || _end.y != 0)
+		if (_end.getX() != 0 || _end.getY() != 0)
 			return;
 
@@ -280,5 +280,5 @@
 	public void setStartCrop(Point p)
 	{
-		if (p != null) setStartCrop(p.x, p.y);
+		if (p != null) setStartCrop(p.getX(), p.getY());
 	}
 	
@@ -291,5 +291,5 @@
 	public void setEndCrop(Point p)
 	{
-		if (p != null) setEndCrop(p.x, p.y);
+		if (p != null) setEndCrop(p.getX(), p.getY());
 	}
 
@@ -304,10 +304,10 @@
 			Point topLeft = getTopLeftCrop();
 			Point bottomRight = getBottomRightCrop();
-			int startX = getX() + topLeft.x - _highlightThickness;
-			int startY = getY() + topLeft.y - _highlightThickness;
+			int startX = getX() + topLeft.getX() - _highlightThickness;
+			int startY = getY() + topLeft.getY() - _highlightThickness;
 			int border = 2 * _highlightThickness;
 			// TODO: Why invalidate specific area just before invalidateAll? cts16
 			invalidate(new AxisAlignedBoxBounds(startX, startY,
-					bottomRight.x - topLeft.x + 2 * border, bottomRight.y - topLeft.y + 2 * border));
+					bottomRight.getX() - topLeft.getX() + 2 * border, bottomRight.getY() - topLeft.getY() + 2 * border));
 			invalidateAll();
 		} else {
@@ -317,11 +317,11 @@
 
 	public Point getTopLeftCrop() {
-		return new Point(Math.min(_cropStart.x, _cropEnd.x), Math.min(
-				_cropStart.y, _cropEnd.y));
+		return new Point(Math.min(_cropStart.getX(), _cropEnd.getX()), Math.min(
+				_cropStart.getY(), _cropEnd.getY()));
 	}
 
 	public Point getBottomRightCrop()
 	{
-		return new Point(Math.max(_cropStart.x, _cropEnd.x), Math.max(_cropStart.y, _cropEnd.y));
+		return new Point(Math.max(_cropStart.getX(), _cropEnd.getX()), Math.max(_cropStart.getY(), _cropEnd.getY()));
 	}
 
@@ -341,6 +341,6 @@
 		if (!isBeingCropped()) return true;
 
-		int cropWidth = Math.abs(_cropEnd.x - _cropStart.x);
-		int cropHeight = Math.abs(_cropEnd.y - _cropStart.y);
+		int cropWidth = Math.abs(_cropEnd.getX() - _cropStart.getX());
+		int cropHeight = Math.abs(_cropEnd.getY() - _cropStart.getY());
 
 		return cropWidth < MINIMUM_WIDTH || cropHeight < MINIMUM_WIDTH;
@@ -371,6 +371,6 @@
 			int height = getHeight();
 			
-			centre.x = base_x + width / 2;
-			centre.y = base_y + height / 2;
+			centre.setX(base_x + width / 2);
+			centre.setY(base_y + height / 2);
 
 			int xdiff = -MARGIN_RIGHT; // -getLeftMargin();
@@ -391,10 +391,10 @@
 			Point bottomRight = getBottomRightCrop();
 			
-			centre.x = base_x + (bottomRight.x - topLeft.x) / 2;
-			centre.y = base_y + (bottomRight.y - topLeft.y) / 2;
-			
-			AxisAlignedBoxBounds clip = new AxisAlignedBoxBounds(topLeft.x + base_x,
-					topLeft.y + base_y, bottomRight.x - topLeft.x,
-					bottomRight.y - topLeft.y);
+			centre.setX(base_x + (bottomRight.getX() - topLeft.getX()) / 2);
+			centre.setY(base_y + (bottomRight.getY() - topLeft.getY()) / 2);
+			
+			AxisAlignedBoxBounds clip = new AxisAlignedBoxBounds(topLeft.getX() + base_x,
+					topLeft.getY() + base_y, bottomRight.getX() - topLeft.getX(),
+					bottomRight.getY() - topLeft.getY());
 //			_poly.addPoint((int) clip.getMinX() - 1, (int) clip.getMinY() - 1);
 //			_poly.addPoint((int) clip.getMinX() - 1, (int) clip.getMaxY());
@@ -425,5 +425,5 @@
 	@Override
 	public void setWidth(Integer width) {
-		_scale = width * 1F / (_end.x - _start.x);
+		_scale = width * 1F / (_end.getX() - _start.getX());
 	}
 
@@ -487,6 +487,6 @@
 		int offY = (tmp.getHeight() - getHeight()) / 2;
 		
-		int cropStartX = _start.x;
-		int cropEndX = _end.x;
+		int cropStartX = _start.getX();
+		int cropEndX = _end.getX();
     	if(cropEndX > iw) {
     		cropEndX = iw;
@@ -503,6 +503,6 @@
 			}
 			
-			int cropStartY = _start.y;
-			int cropEndY = _end.y;
+			int cropStartY = _start.getY();
+			int cropEndY = _end.getY();
         	if(cropEndY > ih) {
         		cropEndY = ih;
@@ -569,8 +569,8 @@
 			int base_y = (_anchorTop != null) ? _anchorTop : _source.getY();
 			
-			Clip clip = new Clip(new AxisAlignedBoxBounds(	base_x + topLeft.x,
-																	base_y + topLeft.y,
-																	bottomRight.x - topLeft.x,
-																	bottomRight.y - topLeft.y));
+			Clip clip = new Clip(new AxisAlignedBoxBounds(	base_x + topLeft.getX(),
+																	base_y + topLeft.getY(),
+																	bottomRight.getX() - topLeft.getX(),
+																	bottomRight.getY() - topLeft.getY()));
 			EnforcedClipKey key = g.pushClip(clip);
 			paintImageTiling();
@@ -625,8 +625,8 @@
 			Point topLeft = getTopLeftCrop();
 			Point bottomRight = getBottomRightCrop();
-			int startX = Math.round(topLeft.x / _scale) + _start.x;
-			int startY = Math.round(topLeft.y / _scale) + _start.y;
-			int endX = Math.round(bottomRight.x / _scale + _start.x);
-			int endY = Math.round(bottomRight.y / _scale + _start.y);
+			int startX = Math.round(topLeft.getX() / _scale) + _start.getX();
+			int startY = Math.round(topLeft.getY() / _scale) + _start.getY();
+			int endX = Math.round(bottomRight.getX() / _scale + _start.getX());
+			int endY = Math.round(bottomRight.getY() / _scale + _start.getY());
 			int width = _image.getWidth();
 			int height = _image.getHeight();
@@ -649,5 +649,5 @@
 			int base_x = (_anchorLeft!=null) ? _anchorLeft : _source.getX();
 			int base_y = (_anchorTop!=null) ? _anchorTop : _source.getY();
-			p._source.setPosition(topLeft.x + base_x, topLeft.y + base_y);
+			p._source.setPosition(topLeft.getX() + base_x, topLeft.getY() + base_y);
 		} else {
 			p._start = new Point(_start);
@@ -678,19 +678,19 @@
 		int ih = _image.getHeight();
 		if(iw > 0 || ih > 0) {
-			while(_start.x >= iw) {
-    			_start.x -= iw;
-    			_end.x -= iw;
+			while(_start.getX() >= iw) {
+    			_start.setX(_start.getX() - iw);
+    			_end.setX(_end.getX() - iw);
     		}
-    		while(_start.y >= ih) {
-    			_start.y -= ih;
-    			_end.y -= ih;
+    		while(_start.getY() >= ih) {
+    			_start.setY(_start.getY() - ih);
+    			_end.setY(_end.getY() - ih);
     		}
-    		while(_start.x < 0) {
-    			_start.x += iw;
-    			_end.x += iw;
+    		while(_start.getX() < 0) {
+    			_start.setX(_start.getX() + iw);
+    			_end.setX(_end.getX() + iw);
     		}
-    		while(_start.y < 0) {
-    			_start.y += ih;
-    			_end.y += ih;
+    		while(_start.getY() < 0) {
+    			_start.setY(_start.getY() + ih);
+    			_end.setY(_end.getY() + ih);
     		}
 		}
@@ -749,13 +749,13 @@
 		}
 		
-		return Image.createImageAsCroppedCopy(_image, _start.x, _start.y, getUnscaledWidth(), getUnscaledHeight());
+		return Image.createImageAsCroppedCopy(_image, _start.getX(), _start.getY(), getUnscaledWidth(), getUnscaledHeight());
 	}
 
 	public int getUnscaledWidth() {
-		return _end.x - _start.x;
+		return _end.getX() - _start.getX();
 	}
 
 	public int getUnscaledHeight() {
-		return _end.y - _start.y;
+		return _end.getY() - _start.getY();
 	}
 
@@ -764,5 +764,5 @@
 	 */
 	public boolean isCropped() {
-		return (_end.x != 0 && _end.x != _image.getWidth()) || (_end.y != 0 && _end.y != _image.getHeight()) || _start.y != 0 || _start.x != 0;
+		return (_end.getX() != 0 && _end.getX() != _image.getWidth()) || (_end.getY() != 0 && _end.getY() != _image.getHeight()) || _start.getY() != 0 || _start.getX() != 0;
 	}
 
@@ -888,8 +888,8 @@
 		// If the image is cropped add the position for the start and finish of
 		// the crop to the soure text
-		if (_start.x > 0 || _start.y > 0 || _end.x != _image.getWidth()
-				|| _end.y != _image.getHeight()) {
-			newText.append(" ").append(_start.x).append(" ").append(_start.y);
-			newText.append(" ").append(_end.x).append(" ").append(_end.y);
+		if (_start.getX() > 0 || _start.getY() > 0 || _end.getX() != _image.getWidth()
+				|| _end.getY() != _image.getHeight()) {
+			newText.append(" ").append(_start.getX()).append(" ").append(_start.getY());
+			newText.append(" ").append(_end.getX()).append(" ").append(_end.getY());
 		}
 		
Index: trunk/src/org/expeditee/items/Text.java
===================================================================
--- trunk/src/org/expeditee/items/Text.java	(revision 1142)
+++ trunk/src/org/expeditee/items/Text.java	(revision 1143)
@@ -727,5 +727,5 @@
 	public void setSelectionStart(Point p)
 	{
-		setSelectionStart(p.x, p.y);
+		setSelectionStart(p.getX(), p.getY());
 	}
 	
@@ -746,5 +746,5 @@
 	public void setSelectionEnd(Point p)
 	{
-		setSelectionEnd(p.x, p.y);
+		setSelectionEnd(p.getX(), p.getY());
 	}
 
@@ -1158,5 +1158,5 @@
 		}
 		
-		if (setSelection) setSelectionEnd(resultPos.x, resultPos.y);
+		if (setSelection) setSelectionEnd(resultPos.getX(), resultPos.getY());
 		
 		return resultPos;
@@ -1178,5 +1178,5 @@
 
 		TextLayout layout = _textLayouts.get(line);
-		mouseX += getOffset().x;
+		mouseX += getOffset().getX();
 		mouseX -= getJustOffset(layout);
 
@@ -1195,5 +1195,5 @@
 	 */
 	public int getLinePosition(float mouseY) {
-		mouseY += getOffset().y;
+		mouseY += getOffset().getY();
 
 		float y = getY();
@@ -1545,5 +1545,5 @@
 	@Override
 	public boolean contains(Point mousePosition) {
-		return contains(mousePosition.x, mousePosition.y, getGravity() * NEARBY_GRAVITY);
+		return contains(mousePosition.getX(), mousePosition.getY(), getGravity() * NEARBY_GRAVITY);
 	}
 	
@@ -1555,6 +1555,6 @@
 	public boolean contains(int mouseX, int mouseY, int gravity)
 	{
-		mouseX += getOffset().x;
-		mouseY += getOffset().y;
+		mouseX += getOffset().getX();
+		mouseY += getOffset().getY();
 
 		float textY = getY();
@@ -1869,5 +1869,5 @@
 			// return;
 		}
-
+		
 		// check if its a vector item and paint all the vector stuff too if this
 		// item is a free item
@@ -2051,5 +2051,5 @@
 				newPoint.set(insertText("\b", mouseX, mouseY, 1));
 				if (_text.length() > 0 && _text.charAt(0) == ' ')
-					newPoint.set(insertText("\b", newPoint.x, newPoint.y, 1));
+					newPoint.set(insertText("\b", newPoint.getX(), newPoint.getY(), 1));
 			} else {
 				newPoint.set(insertText("@", mouseX, mouseY, 0));
@@ -2061,5 +2061,5 @@
 			if (!isLineEnd() && _text.charAt(0) == '@') {
 				newPoint.set(insertText("\b", mouseX, mouseY, 1));
-				newPoint.set(insertText(DEFAULT_BULLET_STRING, newPoint.x, newPoint.y, 0));
+				newPoint.set(insertText(DEFAULT_BULLET_STRING, newPoint.getX(), newPoint.getY(), 0));
 			} else {
 				newPoint.set(insertText("\b", mouseX, mouseY, 1));
@@ -2068,5 +2068,5 @@
 		FrameUtils.setLastEdited(this);
 		rebuild(true);
-		DisplayController.setCursorPosition(newPoint.x, newPoint.y, false);
+		DisplayController.setCursorPosition(newPoint.getX(), newPoint.getY(), false);
 	}
 
@@ -2838,5 +2838,5 @@
 
 		Point newMouse = t.insertChar(start, DisplayController.getMouseX(), DisplayController.getMouseY());
-		DisplayController.setCursorPosition(newMouse.x, newMouse.y, false);
+		DisplayController.setCursorPosition(newMouse.getX(), newMouse.getY(), false);
 
 		return t;
Index: trunk/src/org/expeditee/items/widgets/HeavyDutyInteractiveWidget.java
===================================================================
--- trunk/src/org/expeditee/items/widgets/HeavyDutyInteractiveWidget.java	(revision 1142)
+++ trunk/src/org/expeditee/items/widgets/HeavyDutyInteractiveWidget.java	(revision 1143)
@@ -273,11 +273,15 @@
 		// Render shaded window over widget
 		g.setColor(SwingConversions.toSwingColor(backgroundColor));
-		g.fillRect(getX(), getY(), getWidth(), getHeight());
-		
+		final int x = getX();
+		final int y = getY();
+		final int width = getWidth();
+		final int height = getHeight();
+		g.fillRect(x, y, width, height);
+				
 		// Center the bar
-		int barX = getX() + BAR_HOROZONTIAL_MARGIN;
-		int barY = getY() + (getHeight() >> 1) - (BAR_HEIGHT >> 1);
-		
-		int barWidth = getWidth() - (BAR_HOROZONTIAL_MARGIN * 2);
+		int barX = x + BAR_HOROZONTIAL_MARGIN;
+		int barY = y + (height >> 1) - (BAR_HEIGHT >> 1);
+		
+		int barWidth = width - (BAR_HOROZONTIAL_MARGIN * 2);
 		if (barWidth <= 0) barWidth = 10;
 		
Index: trunk/src/org/expeditee/items/widgets/SwingWidget.java
===================================================================
--- trunk/src/org/expeditee/items/widgets/SwingWidget.java	(revision 1142)
+++ trunk/src/org/expeditee/items/widgets/SwingWidget.java	(revision 1143)
@@ -4,4 +4,5 @@
 import java.awt.Container;
 import java.awt.Graphics2D;
+import java.awt.Point;
 
 import javax.swing.JComponent;
@@ -109,6 +110,7 @@
 		Graphics2D g = SwingMiscManager.getIfUsingSwingGraphicsManager().getCurrentSurface();
 
-		int x = getX();
-		int y = getY();
+		final Point location = _swingComponent.getLocation();
+		int x = location.x;
+		int y = location.y;
 		
 		g.translate(x, y);
Index: trunk/src/org/expeditee/items/widgets/Widget.java
===================================================================
--- trunk/src/org/expeditee/items/widgets/Widget.java	(revision 1142)
+++ trunk/src/org/expeditee/items/widgets/Widget.java	(revision 1143)
@@ -900,5 +900,5 @@
 		
 		_settingPositionFlag = true;
-
+		
 		invalidateLink();
 
Index: trunk/src/org/expeditee/items/widgets/charts/AbstractChart.java
===================================================================
--- trunk/src/org/expeditee/items/widgets/charts/AbstractChart.java	(revision 1142)
+++ trunk/src/org/expeditee/items/widgets/charts/AbstractChart.java	(revision 1143)
@@ -175,6 +175,6 @@
 				Point origin = getOrigin();
 				return new MouseEvent((Component) e.getSource(), e.getID(), e
-						.getWhen(), e.getModifiers(), origin.x + e.getX(),
-						origin.y + e.getY(), e.getXOnScreen(),
+						.getWhen(), e.getModifiers(), origin.getX() + e.getX(),
+						origin.getY() + e.getY(), e.getXOnScreen(),
 						e.getYOnScreen(), e.getClickCount(), false, e
 								.getButton());